#!/usr/bin/env python

import time
import random

import rpyc
from rpyc.utils.server import ThreadedServer
from threading import Thread


# Actual Access Point Logic
class CL:
    
    def __init__(self):
        self.message = 0
        self.intercepted = False
        self.replayCounter = None
        self.ANonce = None
        self.SNonce = None
        self.MAC = '34-25-B8-1C-17-EB'
        self.apconn = None
        self.ap = None
        self.jammed = False
        self.m1 = None
        self.m3 = None
        self.reset = False

    def getMessage1(self, mnum, message):
        self.m1 = message
        self.message = mnum
        print('Recieved Message 1:')
        print(self.m1)

    def getMessage3(self, mnum, message):
        if (self.m3 == None):
            self.m3 = message
            self.message = mnum
            print('Recieved Message 3:')
            print(self.m3)
        else:
            self.reset = True
    
    def getHijacked(self):
        self.apconn = rpyc.connect("localhost", 18814)
        self.ap = self.apconn.root
        self.ap.exposed_reqConnection()
        return(self.message)

    def reqAPConnection(self):
        print('connecting')
        self.apconn = rpyc.connect("localhost", 18812)
        self.ap = self.apconn.root
        self.ap.exposed_reqConnection()

# RPYC Server Stuff
class CLService(rpyc.Service):
    
    def exposed_sendMessage1(self, mnum, message):
        cl.getMessage1(mnum, message)

    def exposed_sendMessage3(self, mnum, message):
        cl.getMessage3(mnum, message)

    def exposed_hijack(self):
        return cl.getHijacked()
        
    
# start the CLserver
server = ThreadedServer(CLService, port = 18813)
t = Thread(target = server.start)
t.daemon = True
t.start()

cl = CL()

input('Initiate 4-way handshake? (y/y) ')
cl.reqAPConnection()

while True:
    time.sleep(1)
    if(cl.message == 1):
        print('sending message 2')
        time.sleep(3)
        cl.ap.exposed_sendMessage2(cl.message, 'SNonce: 8737282, MIC: 7382888')
        print('sent message 2')
        time.sleep(3)
    if(cl.message == 3):
        print('sending message 4')
        time.sleep(3)
        cl.ap.exposed_sendMessage4(cl.message, 'all good fam, handshake complete')
        print('sent message 4')
        time.sleep(3)
        cl.message = 5
    if(cl.message == 5):
        print('sending encrypted message 1')
        time.sleep(3)
        cl.ap.exposed_sendMessage5(cl.message, 'd5e227f5ef7d9d9cfbaaa38bc7aa1dd44091bffcf7a43d478d8c8b49668cbe5d0949681cd60e17db5144eece49ba73f1d1ecfeaca68005b11a47799c7fa85c94e8443ba99492c9e0e86960a9b9620e125d809c')
        print('sent encrypted message 1')
        time.sleep(3)
        cl.message = 6
    if(cl.message == 6):
        print('sending encrypted message 2')
        time.sleep(3)
        if (cl.reset == False):
            cl.ap.exposed_sendMessage6(cl.message, 'd41a34b75858687183bb647c32e06c947f5b8b060a74bb30888f52debc9d4b38d51eb6a06cccc73eed47ee170d0856b9c050b95f8a3839e293f2011848b862685f538ef53c6a06c7e39b9e705902b3e15a7a9b')
        else:
            cl.ap.exposed_sendMessage6(cl.message, 'd2ff36e4bd349dd5b8ada89382bc00974b87baa8f1a1730a859e9649668cbe5d0e087859db1300ce0507e6d449bd65f9dba5feaba18812f40803619231a55c95ac073dbfc483d0a5f22c76b2b22b17134c83c1')
        print('sent encrypted message 2')
        print('Communications done')
        break
    
